Index: /branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8174)
+++ /branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8175)
@@ -426,7 +426,7 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_ymtrp_ice !: Y-component of ice mass transport (kg/s)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_xmtrp_snw !: X-component of snow mass transport (kg/s)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_ymtrp_ice !: Y-component of snow mass transport (kg/s)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_xatran   !: X-component of area transport (m2/s)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_yatran   !: Y-component of area transport (m2/s)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_ymtrp_snw !: Y-component of snow mass transport (kg/s)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_xatrp    !: X-component of area transport (m2/s)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_yatrp    !: Y-component of area transport (m2/s)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_fc_bo    !: Bottom conduction flux (W/m2)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_fc_su    !: Surface conduction flux (W/m2)
Index: /branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90
===================================================================
--- /branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90	(revision 8174)
+++ /branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90	(revision 8175)
@@ -68,20 +68,4 @@
          &         zdiag_volu_sh 
 
-!     ! Strait / passage fluxes (SIMIP)
-!     REAL(wp), DIMENSION(4) ::  &                                    ! Strait fluxes for output
-!        &         zdiag_area_strait  ,   &                                    ! 1=Fram Strait, 2=CAA, 3= Barents, 4 = Bering
-!        &         zdiag_mice_strait  ,   &
-!        &         zdiag_msno_strait
-
-!     REAL(wp) :: zfarea_u, zfmice_u, zfmsno_u, zfarea_v, zfmice_v, zfmsno_v   ! dummy fluxes
-
-!     REAL(wp), DIMENSION(11) :: &
-!        &         zui, zuj, zvi, zvj                                          ! strait addresses
-
-!     INTEGER  :: Nu, Nv, &                                                    ! passage size
-!                 i_strait                                                     ! strait number
-
-!     INTEGER, DIMENSION(4)  :: ji0, ji1, jj0, jj1
-      
       !!-------------------------------------------------------------------
 
@@ -362,232 +346,4 @@
 
       ENDIF 
-!      !-------------------------------------
-!      ! Area, ice mass and snow mass fluxes
-!      !-------------------------------------
-!      ! SIMIP requires fluxes through passages and straits
-!      ! Easiest implementation is via offline python script
-!      ! strait_ar_x
-!
-!      !--------------------------------
-!      ! Fluxes through straits (SIMIP)
-!      !--------------------------------
-!      !
-!      ! Valid only for ORCA-like grids
-!      !
-!      ! 4 Arctic passages are considered (Fram, CAA, Barents, Bering; see Notz et al (GMD 2016) for definitions)
-!      !
-!      ! Fram and Bering  straits are easy because they follow parallels
-!      ! Barents and Canadian Arctic Archipelago are less easy because they do not, which is why they look so awful.
-!      ! 
-!
-!      IF ( iom_use( "strait_arfl" ) .OR. iom_use( "strait_mifl" ) .OR. iom_use( "strait_msfl" ) .AND. cp_cfg == "orca" ) THEN
-!
-!         zdiag_area_strait(:) = 0._wp   ;   zdiag_mice_strait(:) = 0._wp   ;   zdiag_msno_strait(:) = 0._wp
-!   
-!         !------------------------------
-!         ! === Fram & Bering Straits ===
-!         !------------------------------
-!          
-!         SELECT CASE ( jp_cfg ) 
-!          
-!         CASE ( 2 )   ! --- ORCA2
-!          
-!            ! Fram Strait   (i_strait = 1)
-!            ji0(1) = 133   ;   ji1(1) = 136
-!            jj0(1) = 136 
-!
-!            ! Bering Strait (i_strait = 4)
-!            ji0(4) = 55    ;   ji1(4) = 56
-!            jj0(4) = 122
-!          
-!         CASE ( 1 )   ! --- eORCA1
-!          
-!            ! Fram Strait
-!            ji0(1) = 268   ;   ji1(1) = 277
-!            jj0(1) = 311
-!
-!            ! Bering Strait
-!            ji0(4) = 113   ;   jj1(4) = 115
-!            jj0(4) = 285
-!           
-!         END SELECT
-!          
-!         DO i_strait = 1, 4, 3
-!
-!            DO ji = mi0( ji0(i_strait) ), mi1(ji1 (i_strait) )
-!               jj = mj0( jj0(i_strait) )
-!   
-!               zdiag_area_strait(i_strait) = zdiag_area_strait(i_strait)                                 &     ! --- ice area flux ---
-!                   &                + at_i(ji,jj-1) * e12t(ji,jj-1) * MAX( v_ice(ji,jj-1), 0.0 )         &     ! northwards (positive) flow
-!                   &                + at_i(ji,jj  ) * e12t(ji,jj)   * MIN( v_ice(ji,jj-1), 0.0 )               ! southwards (negative) flow
-!      
-!               zdiag_mice_strait(i_strait) = zdiag_mice_strait(i_strait) + rhoic *                       &     ! --- ice mass flux  ---
-!                   &                ( vt_i(ji,jj-1) * e12t(ji,jj-1) * MAX( v_ice(ji,jj-1), 0.0 )         & 
-!                   &                + vt_i(ji,jj  ) * e12t(ji,jj)   * MIN( v_ice(ji,jj-1), 0.0 ) )         
-!      
-!               zdiag_msno_strait(i_strait) = zdiag_msno_strait(i_strait) + rhosn *                       &     ! --- snow mass flux ---
-!                   &                ( vt_s(ji,jj-1) * e12t(ji,jj-1) * MAX( v_ice(ji,jj-1), 0.0 )         & 
-!                   &                + vt_s(ji,jj  ) * e12t(ji,jj)   * MIN( v_ice(ji,jj-1), 0.0 ) )  
-!   
-!            END DO
-!
-!         END DO
-!
-!         !---------------------
-!         ! === Barents opening
-!         !---------------------
-!   
-!         SELECT CASE ( jp_cfg ) 
-!
-!            CASE ( 1 )   ! 'eORCA1'
-!
-!               Nu = 11   ! U-Flow
-!               zui(1:Nu) = (/ 282,283,284,285,286,286,287,288,289,290,292/)
-!               zuj(1:Nu) = (/ 308,307,306,305,304,303,302,301,300,299,298/)
-!
-!               Nv = 9    ! V-Flow
-!               zvi(1:Nv) = (/ 282,283,284,285,286,287,288,289,290/)
-!               zvj(1:Nv) = (/ 308,307,306,305,303,302,301,300,299/)
-!
-!            CASE ( 2 )   ! 'ORCA2'
-!
-!               Nu = 5    ! U-Flow
-!               zui(1:Nu) = (/ 141,142,142,143,144 /)
-!               zuj(1:Nu) = (/ 134,133,132,131,130 /)
-!
-!               Nv = 4    ! V-Flow
-!               zvi(1:Nv) = (/ 140,141,142,143 /)
-!               zvj(1:Nv) = (/ 135,134,132,131 /)
-!
-!         END SELECT
-!
-!         ! Barents U-flow
-!         zfarea_u = 0._wp   ;   zfmice_u = 0._wp   ;   zfmsno_u = 0._wp
-!   
-!         DO ii = 1, Nu
-!
-!            ji = mi0(zui(ii))
-!            jj = mj0(zuj(ii))
-!
-!            zfarea_u          = zfarea_u                                           & ! --- ice area zonal flux ---
-!                &             + at_i(ji-1,jj) * e12t(ji-1,jj) * MAX( u_ice(ji-1,jj), 0.0 )         & ! --- northward
-!                &             + at_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji-1,jj), 0.0 )           ! --- southward
-!            zfmice_u          = zfmice_u + rhoic *                                 & ! --- ice mass zonal flux --- 
-!                &             ( vt_i(ji-1,jj) * e12t(ji-1,jj) * MAX( u_ice(ji-1,jj), 0.0 )         &   
-!                &             + vt_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji-1,jj), 0.0 ) )          
-!            zfmsno_u          = zfmsno_u + rhosn *                                 & ! --- snow mass zonal flux --- 
-!                &             ( vt_s(ji-1,jj) * e12t(ji-1,jj) * MAX( u_ice(ji-1,jj), 0.0 )         &   
-!                &             + vt_s(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji-1,jj), 0.0 ) )          
-!         END DO
-!   
-!         ! Barents V-flow
-!         zfarea_v = 0._wp   ;   zfmice_v = 0._wp   ;   zfmsno_v = 0._wp
-!
-!         DO ii  = 1, Nv  
-!
-!            ji = mi0(zvi(ii))
-!            jj = mj0(zvj(ii))
-!
-!            zfarea_v          = zfarea_v                                           & ! --- ice area meridian flux ---
-!                &             + at_i(ji,jj-1) * e12t(ji,jj-1) * MAX( u_ice(ji,jj-1), 0.0 )         & ! --- eastward
-!                &             + at_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji,jj-1), 0.0 )           ! --- westward
-!            zfmice_v          = zfmice_v + rhoic *                                 & ! --- ice mass meridian flux ---
-!                &             ( vt_i(ji,jj-1) * e12t(ji,jj-1) * MAX( u_ice(ji,jj-1), 0.0 )         & !
-!                &             + vt_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji,jj-1), 0.0 ) )         !
-!            zfmsno_v          = zfmsno_v + rhosn *                                 & ! --- snow mass meridian flux ---
-!                &             ( vt_i(ji,jj-1) * e12t(ji,jj-1) * MAX( u_ice(ji,jj-1), 0.0 )         & !
-!                &             + vt_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji,jj-1), 0.0 ) )         !
-!         END DO
-!   
-!         ! Sum Barents U-/V- contributions
-!         zdiag_area_strait(3) = zfarea_u + zfarea_v 
-!         zdiag_mice_strait(3) = zfmice_u + zfmice_v
-!         zdiag_msno_strait(3) = zfmsno_u + zfmsno_v
-!
-!         !---------------------
-!         ! === CAA throughflow
-!         !---------------------
-!   
-!         SELECT CASE ( jp_cfg ) 
-!
-!            CASE ( 1 )   ! eORCA1
-!
-!               ! V-flow through Nares Strait
-!               Nv = 4
-!               zvi(1:Nv) = (/ 254,255,256,257 /)
-!               zvj(1:Nv) = (/ 317,317,317,317 /)
-!
-!               ! U-flow through Queen Elisabeth Islands and McClure straits
-!               Nu = 8 
-!               zui(1:Nu) = (/ 231,231,231,  132,132,132,132,132  /)
-!               zuj(1:Nu) = (/ 328,329,330,  318,319,320,321,322  /)
-!
-!               zfarea_u = 0._wp   ;   zfmice_u = 0._wp   ;   zfmsno_u = 0._wp
-!
-!               DO ii = 1, Nu
-!
-!                  ji = mi0(zui(ii))
-!                  jj = mj0(zuj(ii))
-!
-!                  zfarea_u          = zfarea_u                                                           & ! --- ice area zonal flux ---
-!                      &             + at_i(ji-1,jj) * e12t(ji-1,jj) * MAX( u_ice(ji-1,jj), 0.0 )         & ! --- eastward
-!                      &             + at_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji-1,jj), 0.0 )           ! --- westward
-!                  zfmice_u          = zfmice_u + rhoic *                                                 & ! --- ice mass zonal flux --- 
-!                      &             ( vt_i(ji-1,jj) * e12t(ji-1,jj) * MAX( u_ice(ji-1,jj), 0.0 )         &   
-!                      &             + vt_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji-1,jj), 0.0 ) )          
-!                  zfmsno_u          = zfmsno_u + rhosn *                                                 & ! --- snow mass zonal flux --- 
-!                      &             ( vt_s(ji-1,jj) * e12t(ji-1,jj) * MAX( u_ice(ji-1,jj), 0.0 )         &   
-!                      &             + vt_s(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji-1,jj), 0.0 ) )          
-!
-!               END DO
-!
-!
-!            CASE ( 2 )   ! ORCA2
-!
-!               ! V-flow through Nares Strait
-!               Nv = 2
-!               zvi(1:Nv) = (/ 117,118 /)
-!               zvj(1:Nv) = (/ 145,145 /)
-!
-!               ! U-flow through Queen Elisabeth Islands and McClure straits (not resolved in ORCA2)
-!               zfarea_u = 0._wp   ;   zfmice_u = 0._wp   ;   zfmsno_u = 0._wp
-!
-!            END SELECT
-!   
-!         ! V-flow through Nares Strait
-!         zfarea_v = 0._wp   ;   zfmice_v = 0._wp   ;   zfmsno_v = 0._wp
-!   
-!         DO ii = 1, Nv  
-!
-!            ji = mi0(zvi(ii))
-!            jj = mj0(zvj(ii))
-!
-!            zfarea_v          = zfarea_v                                           & ! --- ice area meridian flux ---
-!                &             + at_i(ji,jj-1) * e12t(ji,jj-1) * MAX( u_ice(ji,jj-1), 0.0 )         & ! --- eastward
-!                &             + at_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji,jj-1), 0.0 )           ! --- westward
-!            zfmice_v          = zfmice_v + rhoic *                                 & ! --- ice mass meridian flux ---
-!                &             ( vt_i(ji,jj-1) * e12t(ji,jj-1) * MAX( u_ice(ji,jj-1), 0.0 )         & !
-!                &             + vt_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji,jj-1), 0.0 ) )         !
-!            zfmsno_v          = zfmsno_v + rhosn *                                 & ! --- snow mass meridian flux ---
-!                &             ( vt_i(ji,jj-1) * e12t(ji,jj-1) * MAX( u_ice(ji,jj-1), 0.0 )         & !
-!                &             + vt_i(ji,jj  ) * e12t(ji,jj)   * MIN( u_ice(ji,jj-1), 0.0 ) )         !
-!
-!         END DO
-!
-!         ! Sum U/V contributions
-!         zdiag_area_strait(2) = zfarea_u + zfarea_v 
-!         zdiag_mice_strait(2) = zfmice_u + zfmice_v
-!         zdiag_msno_strait(2) = zfmsno_u + zfmsno_v
-!   
-!         ! === Ncdf output
-!         IF ( iom_use("strait_arfl") ) CALL iom_put( "strait_arfl", zdiag_area_strait )
-!         IF ( iom_use("strait_mifl") ) CALL iom_put( "strait_mifl", zdiag_mice_strait )
-!         IF ( iom_use("strait_msfl") ) CALL iom_put( "strait_msfl", zdiag_msno_strait ) 
-!
-!         WRITE(numout,*) " area flx ", zdiag_area_strait(:)
-!         WRITE(numout,*) " mice flx ", zdiag_mice_strait(:)
-!         WRITE(numout,*) " msno flx ", zdiag_msno_strait(:)
-!
-!      ENDIF
 
       !     !  Create an output files (output.lim.abort.nc) if S < 0 or u > 20 m/s